Core - Bug # 66614

Status: Resolved Priority: Must have
Author: Markus Klein Category: File Abstraction Layer (FAL)
Created: 2015-04-27 Assigned To: Markus Klein
Updated: 2015-06-10 Due date:

TYPO3 Version: 6.2

PHP Version:

Complexity: hard

Is Regression: No

Sprint Focus: Stabilization Sprint

Subject: FAL processed files are deleted

Description

How to reproduce

- set “config.noScaleUp =0 in TS
- add a magic image to RTE
- preview the page in FE

Result: Image broken

Root cause

Setting config.noScaleUp causes this line to be executed in typo3/sysext/frontend/Classes/Page/PageGenerator.php:88

$GLOBALS[TYPO3_CONF_VARST[GFX][im_noScaleUp'] = isset($GLOBALS['TSFE']->config['config]['noScaleUp'))

? " . $GLOBALS['TSFE']->config['config']['noScaleUp']
: $GLOBALS['TYPO3_CONF_VARS'['GFX]['im_noScaleUp';

This makes ['GFX']['im_noScaleUp'] a string, while in BE (when the preview image is generated in RTE) this is only loaded from

install tool, where this is a boolean value.

This tiny difference has the effect that the calculated checksums used to determine whether a processed file already exists mismatch

and the already generated processed file is deleted from disk.

Related issues:
related to Core - Task # 67071: Add cleanup tool for processed files to Insta... Resolved
related to Core - Bug # 67385: SQL parser does not support string as join con... Resolved

2015-05-21
2015-06-10

Associated revisions

Revision ab13da3d - 2015-06-10 09:40 - Markus Klein

[BUGFIX] Avoid unnecessary generation of processed files

Removing [GFX] off the checksum data used to identify a processed file
ensures that data type inconsistencies within [GFX] do not cause a

regeneration of the processed file.

A new upgrade wizard for the Install Tool is added to migrate existing
processed files without the need to regenerate those.

Resolves: #66614
Releases: master, 6.2
Change-Id: 1d90ce923b26ee726d15cf3d0cfcafc4ec4d7405d
Reviewed-on: http://review.typo3.org/39644

Reviewed-by: Andreas Fernandez <typo3@scripting-base.de>

Reviewed-by: Xavier Perseguers <xavier@typo3.org>
Tested-by: Xavier Perseguers <xavier@typo3.org>

Reviewed-by: Stefan Neufeind <typo3.neufeind@speedpartner.de>

Reviewed-by: Alexander Opitz <opitz.alexander@googlemail.com>

Tested-by: Alexander Opitz <opitz.alexander@googlemail.com>

Revision 9067813e - 2015-06-10 11:19 - Xavier Perseguers

[BUGFIX] SQL parser does not support string as join condition

The SQL parser is capable of parsing
JOIN T1 ON T1.some_field = T2.some_other_field

and
JOIN T1 ON T1.some_field = 4

but not
JOIN T1 ON T1.some_field = 'some string'

Change-Id: 17806699ea44685ab717cc0e8a75f7b53a1b2b1cc
Resolves: #67385

Related: #66614

Releases: master, 6.2

Reviewed-on: http://review.typo3.org/40144

Reviewed-by: Andreas Fernandez <typo3@scripting-base.de>

Tested-by: Andreas Fernandez <typo3@scripting-base.de>

Reviewed-by: Alexander Opitz <opitz.alexander@googlemail.com>
Reviewed-by: Xavier Perseguers <xavier@typo3.org>
Tested-by: Xavier Perseguers <xavier@typo3.org>

Revision 6d44ed99 - 2015-06-10 11:25 - Xavier Perseguers

[BUGFIX] SQL parser does not support string as join condition

The SQL parser is capable of parsing
JOIN T1 ON T1.some_field = T2.some_other_field

and
JOIN T1 ON T1.some_field = 4

but not
JOIN T1 ON T1.some_field = 'some string'

Change-Id: 17806699ea44685ab717cc0e8a75f7b53a1b2b1cc
Resolves: #67385

Related: #66614

Releases: master, 6.2

Reviewed-on: http://review.typo3.org/40145
Reviewed-by: Xavier Perseguers <xavier@typo3.org>

Tested-by: Xavier Perseguers <xavier@typo3.org>

Revision 66ab2d68 - 2015-06-10 11:30 - Alexander Opitz

[BUGFIX] Avoid unnecessary generation of processed files

Removing [GFX] off the checksum data used to identify a processed file
ensures that data type inconsistencies within [GFX] do not cause a
regeneration of the processed file.

A new upgrade wizard for the Install Tool is added to migrate existing
processed files without the need to regenerate those.

Resolves: #66614

Releases: master, 6.2

Change-Id: [d90ce923b26ee726d15cf3d0cfcafc4ec4d7405d
Reviewed-on: http:/review.typo3.0rg/40143

Reviewed-by: Xavier Perseguers <xavier@typo3.org>
Tested-by: Xavier Perseguers <xavier@typo3.org>

Revision acdca0a6 - 2015-07-20 19:27 - Morton Jonuschat

[BUGFIX] Make ProcessedFileChecksumUpdate compatible with DBAL

Use explicit CAST statements in the SQL queries performed by the
updater to allow other DBMS to compare a VARCHAR with an INT field.

The SQLparser has been extended to support CAST statements as part
of a JOIN clause.

Resolves: #67708

Related: #66614

Releases: master

Change-Id: 14a13eae92290b9ce8149aa5ef93df1305c02715a
Reviewed-on: http://review.typo3.0rg/40576

Reviewed-by: Markus Klein <markus.klein@typo3.org>

Reviewed-by: Andreas Fernandez <typo3@scripting-base.de>

Tested-by: Andreas Fernandez <typo3@scripting-base.de>

Reviewed-by: Xavier Perseguers <xavier@typo3.org>
Reviewed-by: Christian Kuhn <lolli@schwarzbu.ch>
Tested-by: Christian Kuhn <lolli@schwarzbu.ch>

History

#1 - 2015-04-27 20:23 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/38972

2015-08-04

3/7


mailto:xavier@typo3.org
mailto:xavier@typo3.org
http://review.typo3.org/40143
mailto:xavier@typo3.org
mailto:xavier@typo3.org
http://review.typo3.org/40576
mailto:markus.klein@typo3.org
mailto:typo3@scripting-base.de
mailto:typo3@scripting-base.de
mailto:xavier@typo3.org
mailto:lolli@schwarzbu.ch
mailto:lolli@schwarzbu.ch
http://review.typo3.org/38972

#2 - 2015-04-27 20:26 - Markus Klein
- Description updated

#3 - 2015-04-27 21:07 - Markus Klein

- Status changed from Under Review to Accepted
- Priority changed from Must have to Should have
- Target version deleted (next-patchlevel)

- Complexity changed from no-brainer to hard

Abandoned patch.

The issue is way more dramatic.

We have the situation that user experience will differ for BE and FE, if GFX|im_noScaleUp does not match config.noScaleUp.
BE and FE would behave differently.

#4 - 2015-05-04 16:55 - Markus Klein
- Priority changed from Should have to Must have
- Target version set to next-patchlevel

#56147 deals with the issue that processed files are not regenerated. This is related here, since with this bug you can trigger the other bug easily.
Actually, if #56147 would be working, | would have never noticed this bug here.

Regarding this issue: We decided to remove the [GFX] part from the checksum and add a cleanup-util to the Install Tool.

#5 - 2015-05-21 02:32 - Markus Klein
- Target version changed from next-patchlevel to 6.2.13
- Sprint Focus set to Stabilization Sprint

| figured out the whole process now.

1. After inserting the magic file into RTE

2. a ProcessedFile is generated for the thumb

3. When calling FE, it tries to render the file but (due to the data type issue) a new thumb (with new filename) is generated (so a new ProcessedFile)

4. Having the click-enlarge static template loaded of RTE, causes it to render the name of the original processed file (from >eObj>parameters, which
contains the parsed RTE content), which has been deleted by the last step, when the new processed file was generated.

5. In FE it looks like the thumb-regeneration has failed, which is not true. Just the filename of the original thumb is used, which does not exist

anymore.

Ultima ratio:
Fixing the configuration change issue (removing GFX from the checksum) fixes the issue. The remaining FAL handling is totally fine in this case.
Implementation steps are:

1. Remove [GFX] from the checksum generated in \TYPO3\CMS\Core\Resource\Processing\AbstractGraphicalTask::getChecksumData()

2. Add a cleanup utility to Install-Tool, which allows to remove all processed files (#67071)

#6 - 2015-05-21 02:37 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/39644

#7 - 2015-05-21 17:19 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/39644

#8 - 2015-05-21 18:54 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/39644

#9 - 2015-05-23 02:26 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/39644

#10 - 2015-05-26 12:54 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/39644

#11 - 2015-05-26 23:54 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/39644

#12 - 2015-05-27 09:25 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/39644

#13 - 2015-05-27 09:31 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/39644

#14 - 2015-05-28 22:08 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/39644
#15 - 2015-06-06 15:38 - Gerrit Code Review

Patch set 10 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/39644

#16 - 2015-06-06 23:39 - Gerrit Code Review

Patch set 11 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/39644

#17 - 2015-06-09 11:05 - Gerrit Code Review

Patch set 12 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/39644

#18 - 2015-06-09 14:34 - Mathias Schreiber
- Target version changed from 6.2.13 to 7.3 (Packages)

#19 - 2015-06-09 17:22 - Gerrit Code Review

Patch set 13 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0org/39644

#20 - 2015-06-10 09:50 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/40143

#21 - 2015-06-10 10:01 - Markus Klein
- Status changed from Under Review to Resolved

- % Done changed from 0 to 100

Applied in changeset commit:ab13da3d0958e00991661c6f48c97fb4e430ddb2.

#22 - 2015-06-10 10:12 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 2 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/40143

#23 - 2015-06-10 12:01 - Alexander Opitz
- Status changed from Under Review to Resolved
Applied in changeset commit:66ab2d684b6a9c7afa18a93175d02c411beac3d6.
